library file.disk;

import 'dart:async';
import 'dart:io' as io;

import 'package:file/file.dart';

/// A wrapper around `dart:io`.
class DiskFileSystem implements FileSystem {
  const DiskFileSystem();

  @override
  Directory getDirectory(String path) {
    return new _DiskDirectory(new io.Directory(path));
  }

  @override
  File getFile(String path) {
    return new _DiskFile(new io.File(path));
  }
}

class _DiskDirectory implements Directory {
  final io.Directory _directory;

  _DiskDirectory(this._directory);

  @override
  Future<bool> get exists => _directory.exists();
}

class _DiskFile implements File {
  final io.File _file;

  _DiskFile(this._file);

  @override
  Future<bool> get exists => _file.exists();
}
