library file;

import 'dart:async';

/// A generic representation of a file system that is pluggable and mockable.
abstract class FileSystem {
  /// Returns a directory handle to [path].
  Directory getDirectory(String path);

  /// Returns a file handle to [path].
  File getFile(String path);
}

/// A generic representation of a file, link, or directory.
abstract class FileSystemEntity {
  /// Returns a future that completes with whether this entity exists.
  Future<bool> get exists;
}

/// A generic representation of a file.
abstract class File extends FileSystemEntity {}

/// A generic representation of a directory.
abstract class Directory extends FileSystemEntity {}
