library file.test.disk_test;

import 'dart:io' as io;

import 'package:file/disk.dart';
import 'package:path/path.dart' as path;
import 'package:test/test.dart';

void main() {
  group('DiskFileSystem', () {
    final name = new DateTime.now().millisecondsSinceEpoch.toString();
    final fs = const DiskFileSystem();

    io.Directory tmp;

    setUp(() {
      tmp = io.Directory.systemTemp.createTempSync(name);
      new io.File(path.join(tmp.path, 'hello.txt')).createSync();
    });

    tearDown(() {
      tmp.deleteSync(recursive: true);
    });

    test('works as expected for directories', () async {
      var exists = await fs.getDirectory(tmp.path).exists;
      expect(exists, isTrue);
      exists = await fs.getDirectory(path.join(tmp.path, 'null')).exists;
      expect(exists, isFalse);
    });

    test('works as expected for files', () async {
      var exists = await fs.getFile(path.join(tmp.path, 'hello.txt')).exists;
      expect(exists, isTrue);
      exists = await fs.getFile(path.join(tmp.path, 'byte.txt')).exists;
      expect(exists, isFalse);
    });
  });
}
